{% extends "base.html.twig" %}

{% block body %}
    <div class="">
        <div class="container-fluid">
            <div class="row">
                <div class="offset-md-10 col-md-2 text-right">
                    
                </div>
            </div>
            <div class="row">
                <div class="col-12">
                    <div class="card">
                        <div class="card-body">
                            <h2 class="card-title float-left">Les devis générés</h2>
                            <div class="float-right">
                                <span style="opacity: 0;" class="text-left loader-year"><i class="fas fa-spinner fa-spin"></i></span>
                                <div class="d-inline text-left">
                                    <select name="year-select" id="year-select" style="width: 100px;">
                                        {% for i in yearOfJoin..currentYear %}
                                            <option{% if i == currentYear %} selected{% endif %} value="{{ i }}">{{ i }}</option>
                                        {% endfor %}
                                    </select>
                                </div>
                            </div>
                            <div style="clear:both;"></div>
                            <div>
                                <canvas id="myChart" width="400" height="400"></canvas>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <div class="container-fluid">
        <div class="row">
            <div class="col-md-6">
                <div class="card">
                    <div class="card-body">
                        <div class="row align-items-center mb-4">
                            <div class="col-md-6">
                                <h2 class="card-title m-0">Chiffre d'affaires potentiel</h2>
                            </div>
                            <div class="col-md-6">
                                <div style="float: right; width: calc(100% - 20px);" class="input-group">
                                    <input type="text" class="form-control daterangeicker-ca">
                                    <div class="input-group-append">
                                        <span class="input-group-text"><i class="mdi mdi-calendar"></i></span>
                                    </div>
                                </div>
                                <span style="float: right; position: relative; top: 7px; right: 5px; opacity: 0;" class="text-left loader-ca"><i class="fas fa-spinner fa-spin"></i></span>
                            </div>
                        </div>
                        <div class="col-md-12"><canvas id="amountChart" width="400" height="400"></canvas></div>
                    </div>
                </div>
            </div>
            <div class="col-md-6">
                <div class="card">
                    <div class="card-body">
                        <div class="row align-items-center mb-4">
                            <div class="col-md-6">
                                <h2 class="card-title m-0">Status des tickets</h2>
                            </div>
                            <div class="col-md-6">
                                <div style="float: right; width: calc(100% - 20px);" class="input-group">
                                    <input type="text" class="form-control daterangeicker-tickets">
                                    <div class="input-group-append">
                                        <span class="input-group-text"><i class="mdi mdi-calendar"></i></span>
                                    </div>
                                </div>
                                <span style="float: right; position: relative; top: 7px; right: 5px; opacity: 0;" class="text-left loader-tickets"><i class="fas fa-spinner fa-spin"></i></span>
                            </div>
                        </div>
                        <div class="col-md-12"><canvas id="ticketChart" width="400" height="400"></canvas></div>
                    </div>
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-md-4">
                <div class="card text-center">
                    <div class="mb-2 card-body text-muted">
                        <h3 class="text-info mt-2">{{ generationCount }}</h3> Générations de devis ce mois
                    </div>
                </div>
            </div>
            <div class="col-md-4">
                <div class="card text-center">
                    <div class="mb-2 card-body text-muted">
                        <h3 class="text-purple mt-2">{{ ticketCount }}</h3> Tickets ouverts ce mois
                    </div>
                </div>
            </div>
            <div class="col-md-4">
                <div class="card text-center">
                    <div class="mb-2 card-body text-muted">
                        <h3 class="text-primary mt-2">{{ productsCount }}</h3> Produits
                    </div>
                </div>
            </div>
        </div>

        {% if is_granted('ROLE_ADMIN') %}
        <div class="row">
            <div class="col-xl-12">
                <div class="card">
                    <div class="card-body">
                        <h4 class="card-title mb-4">Utilisateurs inscrits</h4>

                        <div class="row text-center mt-4">
                            <div class="col-6">
                                <h5 class="mb-2 font-size-18">{{ providersCount }}</h5>
                                <p class="text-muted text-truncate">Fournisseurs</p>
                            </div>
                            <div class="col-6">
                                <h5 class="mb-2 font-size-18">{{ clientsCount }}</h5>
                                <p class="text-muted text-truncate">Clients</p>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        {% endif %}

        <div class="row">
            <div class="col-xl-6">
                <div class="card">
                    <div class="card-body">
                        <h4 class="card-title mb-4">Tickets ouverts</h4>

                        <div class="table-responsive">
                            <table class="table mt-4 mb-0 table-centered table-nowrap">
                                {% for ticket in tickets %}
                                    <tr>
                                        <td><a class="text-info" href="{{ path('dashboard_user_show', {id: ticket.client.id}) }}">{{ ticket.client }}</a></td>
                                        {% if is_granted('ROLE_ADMIN') %}
                                            <td><a class="text-info" href="{{ path('dashboard_user_show', {id: ticket.provider.id}) }}">{{ ticket.provider }}</a></td>
                                        {% endif %}
                                        <td>{{ ticket.createdAt ? ticket.createdAt|date('d/m/Y H:i:s') : '' }}</td>
                                        <td>
                                            {% if ticket.state == 0 %}
                                                <span class="badge badge-success">Non traité</span>
                                            {% elseif ticket.state == 1 %}
                                                <span class="badge badge-info">En cours</span>
                                            {% else %}
                                                <span class="badge badge-secondary">Fermée</span>
                                            {% endif %}
                                        </td>
                                        <td class="text-right">
                                            <a class="btn btn-sm btn-primary" href="{{ path('dashboard_ticket_show', {'id': ticket.id}) }}">Voir le ticket</a>
                                        </td>
                                    </tr>
                                {% else %}
                                    <tr>
                                        <td class="text-center">Aucun élément trouvé</td>
                                    </tr>
                                {% endfor %}
                            </table>
                            <span class="d-block text-center mt-3"><a class="text-info" href="{{ path('dashboard_ticket_index') }}">Voir tous les éléments</a></span>
                        </div>
                    </div>
                </div>
            </div>

            <div class="col-xl-6">
                <div class="card">
                    <div class="card-body">
                        <h4 class="card-title mb-4">Devis générés</h4>

                        <div class="table-responsive">
                            <table class="table mt-4 mb-0 table-centered table-nowrap">
                                {% for quote_generation in quote_generations %}
                                <tr>
                                    <td>{{ quote_generation.client }}</td>
                                    {% if is_granted('ROLE_ADMIN') %}
                                        <td>{{ quote_generation.provider }}</td>
                                    {% endif %}
                                    <td>{{ quote_generation.createdAt ? quote_generation.createdAt|date('d/m/Y H:i:s') : '' }}</td>
                                    <td>{{ quote_generation.amount }} TND</td>
                                    <td class="text-right">
                                        <a class="btn btn-sm btn-primary" href="{{ path('dashboard_quote_generation_show', {'id': quote_generation.id}) }}"><i class="fa fa-eye"></i></a>
                                    </td>
                                </tr>
                                {% else %}
                                    <tr>
                                        <td class="text-center">Aucun élément trouvé</td>
                                    </tr>
                                {% endfor %}
                            </table>
                            <span class="d-block text-center mt-3"><a class="text-info" href="{{ path('dashboard_quote_generation_index') }}">Voir tous les éléments</a></span>
                        </div>
                    </div>
                </div>
            </div>

        </div>
    </div>
{% endblock %}

{% block javascripts %}
    <script src="{{ asset('assets/libs/chart.js/Chart.bundle.min.js') }}"></script>
    <script src="{{ asset('assets/libs/daterangepicker/moment.min.js') }}"></script>
    <script src="{{ asset('assets/libs/daterangepicker/daterangepicker.js') }}"></script>
    <script>
        // quotes chart
        let ctx = document.getElementById('myChart').getContext('2d');
        let myChart = new Chart(ctx, {
            type: 'bar',
            data: {
                labels: [
                    {% for date in volume[0].values %}
                    '{{ date.date }}',
                    {% endfor %}
                ],
                datasets: [
                    {
                        label: '{{ volume[0].key }}',
                        backgroundColor: 'rgba(119, 201, 73, 0.7)',
                        borderColor: 'rgba(119, 201, 73, 0.7)',
                        fill: !0,
                        lineTension: .5,
                        borderCapStyle: "butt",
                        borderDash: [],
                        borderDashOffset: 0,
                        borderJoinStyle: "miter",
                        pointBorderColor: "#67479e",
                        pointBackgroundColor: "#fff",
                        pointBorderWidth: 1,
                        pointHoverRadius: 5,
                        pointHoverBackgroundColor: "#67479e",
                        pointHoverBorderColor: "#eef0f2",
                        pointHoverBorderWidth: 2,
                        pointRadius: 1,
                        pointHitRadius: 10,
                        data: [
                            {% for a in volume[0].values %}
                            {
                                x: '{{ a.date }}',
                                y: {{ a.count }}
                            },
                            {% endfor %}
                        ]
                    },
                    {
                        label: '{{ volume[1].key }}',
                        backgroundColor: 'rgba(75, 187, 206, .7)',
                        borderColor: 'rgba(75, 187, 206)',
                        fill: !0,
                        lineTension: .5,
                        borderCapStyle: "butt",
                        borderDash: [],
                        borderDashOffset: 0,
                        borderJoinStyle: "miter",
                        pointBorderColor: "#67479e",
                        pointBackgroundColor: "#fff",
                        pointBorderWidth: 1,
                        pointHoverRadius: 5,
                        pointHoverBackgroundColor: "#67479e",
                        pointHoverBorderColor: "#eef0f2",
                        pointHoverBorderWidth: 2,
                        pointRadius: 1,
                        pointHitRadius: 10,
                        data: [
                            {% for a in volume[1].values %}
                            {
                                x: '{{ a.date }}',
                                y: {{ a.count }},
                            },
                            {% endfor %}
                        ]
                    }
                ]
            },
            options: {
                maintainAspectRatio: false,
                scales: {
                    yAxes: [{
                        ticks: {
                            beginAtZero:true,
                            userCallback: function(label, index, labels) {
                                if (Math.floor(label) === label) {
                                    return label;
                                }

                            },
                        }
                    }]
                }
            }
        });

        $('#year-select').change(function () {
            let year = $(this).val();
            $('.loader-year').css('opacity', 1);
            $.ajax({
                type: "post",
                url: "{{ path('dashboard_yearly_graph_volume') }}",
                data: {year: year}
            }).done(function (jqxhr) {
                $('.loader-year').css('opacity', 0);
                let volume = JSON.parse(jqxhr);
                let labels = [];
                let values1 = [];
                let values2 = [];

                for (let i in volume[0].values) {
                    let element = volume[0].values[i];
                    labels.push(element.date);
                    values1.push({x: element.date, y: element.count})
                }

                for (let i in volume[1].values) {
                    let element = volume[1].values[i];
                    values2.push({x: element.date, y: element.count})
                }

                myChart.destroy();
                myChart = new Chart(ctx, {
                    type: 'bar',
                    data: {
                        labels: labels,
                        datasets: [
                            {
                                label: volume[0].key,
                                backgroundColor: 'rgba(119, 201, 73, 0.7)',
                                borderColor: 'rgba(119, 201, 73, 0.7)',
                                fill: !0,
                                lineTension: .5,
                                borderCapStyle: "butt",
                                borderDash: [],
                                borderDashOffset: 0,
                                borderJoinStyle: "miter",
                                pointBorderColor: "#67479e",
                                pointBackgroundColor: "#fff",
                                pointBorderWidth: 1,
                                pointHoverRadius: 5,
                                pointHoverBackgroundColor: "#67479e",
                                pointHoverBorderColor: "#eef0f2",
                                pointHoverBorderWidth: 2,
                                pointRadius: 1,
                                pointHitRadius: 10,
                                data: values1
                            },
                            {
                                label: volume[1].key,
                                backgroundColor: 'rgba(75, 187, 206, .7)',
                                borderColor: 'rgba(75, 187, 206)',
                                fill: !0,
                                lineTension: .5,
                                borderCapStyle: "butt",
                                borderDash: [],
                                borderDashOffset: 0,
                                borderJoinStyle: "miter",
                                pointBorderColor: "#67479e",
                                pointBackgroundColor: "#fff",
                                pointBorderWidth: 1,
                                pointHoverRadius: 5,
                                pointHoverBackgroundColor: "#67479e",
                                pointHoverBorderColor: "#eef0f2",
                                pointHoverBorderWidth: 2,
                                pointRadius: 1,
                                pointHitRadius: 10,
                                data: values2
                            }
                        ]
                    },
                    options: {
                        maintainAspectRatio: false,
                        scales: {
                            yAxes: [{
                                ticks: {
                                    beginAtZero:true,
                                    userCallback: function(label, index, labels) {
                                        if (Math.floor(label) === label) {
                                            return label;
                                        }
                                    },
                                }
                            }]
                        }
                    }
                });
            });
        });
        $(function () {
            $('#year-select').select2({
                minimumResultsForSearch: -1
            })
        });


        // amount chart
        let amountConfig = {
            type: 'pie',
            data: {
                datasets: [{
                    data: [
                        {% if amounts[1] is defined %}
                        {{ amounts[1].sum }},
                        {% endif %}
                        {% if amounts[0] is defined %}
                        {{ amounts[0].sum }},
                        {% endif %}
                    ],
                    backgroundColor: [
                        "rgba(234, 30, 99, .7)",
                        "rgba(103, 71, 158, 0.7)",
                    ],
                    label: "Chiffre d'affaires potentiel"
                }],
                labels: [
                    'Achat demandé',
                    'Achat Non demandé',
                ]
            },
            options: {
                maintainAspectRatio: false,
                responsive: true,
                tooltips: {
                    callbacks: {
                        title: function (tooltipItem, data) {
                            return data['labels'][tooltipItem[0]['index']];
                        },
                        label: function (tooltipItem, data) {
                            return data['datasets'][0]['data'][tooltipItem['index']] + " TND";
                        }
                    }
                }
            }
        };
        let ctxAmount = document.getElementById('amountChart').getContext('2d');
        window.myPie = new Chart(ctxAmount, amountConfig);


        // Tickets chart
        let ticketsConfig = {
            type: 'pie',
            data: {
                datasets: [{
                    data: [
                        {{ ticketStates[0] }},
                        {{ ticketStates[1] }},
                        {{ ticketStates[2] }},
                        {{ ticketStates[3] }},
                        {{ ticketStates[4] }},
                    ],
                    backgroundColor: [
                        "rgba(243, 156, 18, .7)",
                        "rgba(52, 152, 219, .7)",
                        "rgba(39, 174, 96, .4)",
                        "rgba(211, 84, 0, .4)",
                    ],
                    label: "Chiffre d'affaires"
                }],
                labels: [
                    'Non traité',
                    'En cours',
                    'Fermé - Achat effectué',
                    'Fermé - Achat non effectué',
                ]
            },
            options: {
                maintainAspectRatio: false,
                responsive: true,
                tooltips: {
                    callbacks: {
                        title: function (tooltipItem, data) {
                            return data['labels'][tooltipItem[0]['index']];
                        },
                        label: function (tooltipItem, data) {
                            return data['datasets'][0]['data'][tooltipItem['index']] + " TND";
                        }
                    }
                }
            }
        };
        let ctxTicket = document.getElementById('ticketChart').getContext('2d');
        let ticketChart = new Chart(ctxTicket, ticketsConfig);


        let rangePickerConfig = {
            //startDate: moment().startOf('hour'),
            //endDate: moment().startOf('hour').add(32, 'hour'),
            //minYear: 1901,
            //maxYear: parseInt(moment().format('YYYY'),10),
            ranges: {
                "Aujourd'jui": [moment(), moment()],
                'Hier': [moment().subtract(1, 'days'), moment().subtract(1, 'days')],
                '7 derniers jours': [moment().subtract(6, 'days'), moment()],
                '30 derniers jours': [moment().subtract(29, 'days'), moment()],
                'Ce mois': [moment().startOf('month'), moment().endOf('month')],
                'Mois dernier': [moment().subtract(1, 'month').startOf('month'), moment().subtract(1, 'month').endOf('month')]
            },
            "startDate": "03/03/2021",
            "endDate": "03/09/2021",
            "alwaysShowCalendars": true,
            "locale": {
                "format": "DD/MM/YYYY",
                "separator": " - ",
                "applyLabel": "Appliquer",
                "cancelLabel": "Annuler",
                "fromLabel": "Début",
                "toLabel": "Fin",
                "customRangeLabel": "Personnalisé",
                "weekLabel": "W",
                "daysOfWeek": [
                    "Dim",
                    "Lun",
                    "Mar",
                    "Mer",
                    "Jeu",
                    "Ven",
                    "Sam"
                ],
                "monthNames": [
                    "Janvier",
                    "Février",
                    "Mars",
                    "Avril",
                    "Mai",
                    "Juin",
                    "Juillet",
                    "Aout",
                    "Septembre",
                    "Octobre",
                    "Novembre",
                    "Decembre"
                ],
                "firstDay": 1,
            }
        };
        $('.daterangeicker-ca').daterangepicker(rangePickerConfig, function(start, end) {
            let $loader = $('.loader-ca');
            $loader.css("opacity", 1);
            $.ajax({
                type: 'post',
                url: '{{ path('dashboard_chart_data_amount') }}',
                data: {start: start.format('YYYY-MM-DD'), end: end.format('YYYY-MM-DD')}
            }).done(function (jqxhr) {
                let data = JSON.parse(jqxhr);
                if (data.length === 0) {
                    amountConfig.data.datasets[0].data = [];
                } else {
                    amountConfig.data.datasets[0].data = [data[1].sum, data[0].sum];
                }
                $loader.css("opacity", 0);
                window.myPie.destroy();
                window.myPie = new Chart(ctxAmount, amountConfig);
            })
        });

        $('.daterangeicker-tickets').daterangepicker(rangePickerConfig, function(start, end,) {
            let $loader = $('.loader-tickets');
            $loader.css("opacity", 1);
            $.ajax({
                type: 'post',
                url: '{{ path('dashboard_chart_data_tickets') }}',
                data: {start: start.format('YYYY-MM-DD'), end: end.format('YYYY-MM-DD')}
            }).done(function (jqxhr) {
                let data = JSON.parse(jqxhr);
                if (data.length === 0) {
                    ticketsConfig.data.datasets[0].data = [];
                } else {
                    ticketsConfig.data.datasets[0].data = data;
                }
                $loader.css("opacity", 0);
                ticketChart.destroy();
                ticketChart = new Chart(ctxTicket, ticketsConfig);
            })
        });
    </script>
{% endblock %}

{% block stylesheets %}
    <link rel="stylesheet" href="{{ asset('assets/libs/daterangepicker/daterangepicker.css') }}">
{% endblock %}